Name: docbook-dtds
Version: 1.0
Release: alt6

Packager: Mikhail Zabaluev <mhz@altlinux.ru>

Summary: SGML and XML document type definitions for DocBook
Group: Publishing
License: Distributable
URL: http://www.oasis-open.org/docbook/

Obsoletes: docbook-dtd30-sgml docbook-dtd31-sgml
Obsoletes: docbook-dtd40-sgml docbook-dtd41-sgml
Obsoletes: docbook-dtd412-xml

Provides: docbook-dtd-xml docbook-dtd-sgml
Provides: docbook-dtd30-sgml docbook-dtd31-sgml
Provides: docbook-dtd40-sgml docbook-dtd41-sgml
Provides: docbook-dtd42-sgml
Provides: docbook-dtd412-xml
Provides: docbook-dtd42-xml

PreReq: sgml-common >= 0.6.3
PreReq: xml-common >= 0.6.3-alt7
PreReq: xml-utils fileutils

BuildArch: noarch

Source0: http://www.oasis-open.org/docbook/sgml/3.0/docbk30.tar.bz2
Source1: http://www.oasis-open.org/docbook/sgml/3.1/docbk31.tar.bz2
Source2: http://www.oasis-open.org/docbook/sgml/4.0/docbk40.tar.bz2
Source3: http://www.oasis-open.org/docbook/sgml/4.1/docbk41.tar.bz2
Source4: http://www.oasis-open.org/docbook/xml/4.1.2/docbkx412.tar.bz2
Source5: http://www.oasis-open.org/docbook/sgml/4.2/docbook-4.2.tar.bz2
Source6: http://www.oasis-open.org/docbook/xml/4.2/docbook-xml-4.2.tar.bz2
Patch0: docbook-dtd30-sgml-%version.catalog.patch
Patch1: docbook-dtd31-sgml-%version.catalog.patch
Patch2: docbook-dtd40-sgml-%version.catalog.patch
Patch3: docbook-dtd41-sgml-%version.catalog.patch
Patch4: docbook-dtd412-xml-%version.catalog.patch
Patch5: docbook-dtd42-sgml-%version.catalog.patch
Patch6: docbook-dtd42-xml-%version.catalogs.patch

#%define openjadever 1.3
#Conflicts: openjade < %openjadever
#Conflicts: openjade > %openjadever

%define xmlbase		%_datadir/xml
%define sgmlbase	%_datadir/sgml
%define xmlconfdir	%_sysconfdir/xml
%define sgmlconfdir	%_sysconfdir/sgml
%define xmlentitiesdir	%xmlbase/xml-iso-entities-8879.1986
%define sgmlentitiesdir	%sgmlbase/sgml-iso-entities-8879.1986

BuildRequires: xml-utils

%description
The DocBook Document Type Definition (DTD) describes the syntax of
technical documentation texts (articles, books and manual pages).
This package contains SGML and XML versions of the DocBook DTD up to
and including version 4.2.

%prep
%setup -q -c -T -a 0 -a 1 -a 2 -a 3 -a 4 -a 5 -a 6
# DocBook V3.0
cd docbook-dtd30-sgml-%version
patch -b docbook.cat %PATCH0
cd ..

# DocBook V3.1
cd docbook-dtd31-sgml-%version
patch -b docbook.cat %PATCH1
cd ..

# DocBook V4.0
cd docbook-dtd40-sgml-%version
patch -b docbook.cat %PATCH2
cd ..

# DocBook V4.1
cd docbook-dtd41-sgml-%version
patch -b docbook.cat %PATCH3
cd ..

# DocBook XML V4.1.2
cd docbook-dtd412-xml-%version
patch -b docbook.cat %PATCH4
cd ..

# DocBook V4.2
cd docbook-dtd42-sgml-%version
patch -b docbook.cat %PATCH5
cd ..

# DocBook XML V4.2
# patch for two catalogs
cd docbook-dtd42-xml-%version
patch -p1 -b <%PATCH6
cd ..

# Documentation
install -d -m755 doc/{3.0,3.1,4.0,4.1,4.2}-sgml
install -d -m755 doc/{4.1.2,4.2}-xml
mv docbook-dtd30-sgml-%version/*.txt		doc/3.0-sgml
mv docbook-dtd31-sgml-%version/*.txt		doc/3.1-sgml
mv docbook-dtd31-sgml-%version/ChangeLog	doc/3.1-sgml
mv docbook-dtd40-sgml-%version/*.txt		doc/4.0-sgml
mv docbook-dtd41-sgml-%version/*.txt		doc/4.1-sgml
mv docbook-dtd41-sgml-%version/ChangeLog	doc/4.1-sgml
mv docbook-dtd412-xml-%version/*.txt		doc/4.1.2-xml
mv docbook-dtd412-xml-%version/ChangeLog	doc/4.1.2-xml
mv docbook-dtd42-sgml-%version/README		doc/4.2-sgml
mv docbook-dtd42-sgml-%version/ChangeLog	doc/4.2-sgml
mv docbook-dtd42-xml-%version/README		doc/4.2-xml
mv docbook-dtd42-xml-%version/ChangeLog		doc/4.2-xml

%install
# DocBook V3.0
cd docbook-dtd30-sgml-%version
DESTDIR=$RPM_BUILD_ROOT%sgmlbase/docbook/sgml-dtd-3.0
install -d -m755 $DESTDIR
install -p -m644 *.dcl $DESTDIR
install -p -m644 docbook.cat $DESTDIR/catalog
install -p -m644 *.dtd $DESTDIR
install -p -m644 *.mod $DESTDIR
cd ..

# DocBook V3.1
cd docbook-dtd31-sgml-%version
DESTDIR=$RPM_BUILD_ROOT%sgmlbase/docbook/sgml-dtd-3.1
install -d -m755 $DESTDIR
install -p -m644 *.dcl $DESTDIR
install -p -m644 docbook.cat $DESTDIR/catalog
install -p -m644 *.dtd $DESTDIR
install -p -m644 *.mod $DESTDIR
cd ..

# DocBook V4.0
cd docbook-dtd40-sgml-%version
DESTDIR=$RPM_BUILD_ROOT%sgmlbase/docbook/sgml-dtd-4.0
install -d -m755 $DESTDIR
install -p -m644 *.dcl $DESTDIR
install -p -m644 docbook.cat $DESTDIR/catalog
install -p -m644 *.dtd $DESTDIR
install -p -m644 *.mod $DESTDIR
cd ..

# DocBook V4.1
cd docbook-dtd41-sgml-%version
DESTDIR=$RPM_BUILD_ROOT%sgmlbase/docbook/sgml-dtd-4.1
install -d -m755 $DESTDIR
install -p -m644 *.dcl $DESTDIR
install -p -m644 docbook.cat $DESTDIR/catalog
install -p -m644 *.dtd $DESTDIR
install -p -m644 *.mod $DESTDIR
cd ..

# DocBook XML V4.1.2
cd docbook-dtd412-xml-%version
DESTDIR=$RPM_BUILD_ROOT%xmlbase/docbook/dtd/4.1.2
RELENTDIR=$(relative %xmlentitiesdir %xmlbase/docbook/dtd/4.1.2/ent/)
install -d -m755 $DESTDIR
install -d -m755 $DESTDIR/ent
install -p -m644 docbook.cat $DESTDIR/catalog
install -p -m644 *.dtd $DESTDIR
install -p -m644 *.mod $DESTDIR
# CATALOG=$DESTDIR/catalog.xml
# %_bindir/xmlcatalog --noout --create $CATALOG
# %_bindir/xmlcatalog --noout --add "public" \
# 	"-//OASIS//DTD DocBook XML V4.1.2//EN" \
# 	"docbookx.dtd" $CATALOG ||:
# %_bindir/xmlcatalog --noout --add "public" \
# 	"-//OASIS//DTD DocBook XML CALS Table Model V4.1.2//EN" \
# 	"calstblx.dtd" $CATALOG ||:
# %_bindir/xmlcatalog --noout --add "public" \
# 	"-//OASIS//DTD XML Exchange Table Model 19990315//EN" \
# 	"soextblx.dtd" $CATALOG ||:
# %_bindir/xmlcatalog --noout --add "public" \
# 	"-//OASIS//ELEMENTS DocBook XML Information Pool V4.1.2//EN" \
# 	"dbpoolx.mod" $CATALOG ||:
# %_bindir/xmlcatalog --noout --add "public" \
# 	"-//OASIS//ELEMENTS DocBook XML Document Hierarchy V4.1.2//EN" \
# 	"dbhierx.mod" $CATALOG ||:
# %_bindir/xmlcatalog --noout --add "public" \
# 	"-//OASIS//ENTITIES DocBook XML Additional General Entities V4.1.2//EN" \
# 	"dbgenent.mod" $CATALOG ||:
# %_bindir/xmlcatalog --noout --add "public" \
# 	"-//OASIS//ENTITIES DocBook XML Notations V4.1.2//EN" \
# 	"dbnotnx.mod" $CATALOG ||:
# %_bindir/xmlcatalog --noout --add "public" \
# 	"-//OASIS//ENTITIES DocBook XML Character Entities V4.1.2//EN" \
# 	"dbcentx.mod" $CATALOG ||:
cd ent
for f in *.ent; do
    %__ln_s -f $RELENTDIR/$f $DESTDIR/ent/$f
done
cd ../..

# DocBook V4.2
cd docbook-dtd42-sgml-%version
DESTDIR=$RPM_BUILD_ROOT%sgmlbase/docbook/sgml-dtd-4.2
install -d -m755 $DESTDIR
install -p -m644 *.dcl $DESTDIR
install -p -m644 docbook.cat $DESTDIR/catalog
install -p -m644 *.dtd $DESTDIR
install -p -m644 *.mod $DESTDIR
cd ..

# DocBook XML V4.2
cd docbook-dtd42-xml-%version
DESTDIR=$RPM_BUILD_ROOT%xmlbase/docbook/dtd/4.2
RELENTDIR=$(relative %xmlentitiesdir %xmlbase/docbook/dtd/4.2/ent/)
install -d -m755 $DESTDIR
install -d -m755 $DESTDIR/ent
install -p -m644 catalog.xml $DESTDIR
install -p -m644 docbook.cat $DESTDIR/catalog
install -p -m644 *.dtd $DESTDIR
install -p -m644 *.mod $DESTDIR
cd ent
for f in *.ent; do
    %__ln_s -f $RELENTDIR/$f $DESTDIR/ent/$f
done
cd ../..

# Hack: back-port XML catalog from 4.2 to 4.1.2
sed -e 's/4\.2/4\.1\.2/g' < docbook-dtd42-xml-%version/catalog.xml \
    > $RPM_BUILD_ROOT%xmlbase/docbook/dtd/4.1.2/catalog.xml

# Create empty centralized SGML catalogs and symlinks
mkdir -p $RPM_BUILD_ROOT%sgmlconfdir
touch $RPM_BUILD_ROOT%sgmlconfdir/sgml-docbook-3.0.cat
touch $RPM_BUILD_ROOT%sgmlconfdir/sgml-docbook-3.1.cat
touch $RPM_BUILD_ROOT%sgmlconfdir/sgml-docbook-4.0.cat
touch $RPM_BUILD_ROOT%sgmlconfdir/sgml-docbook-4.1.cat
touch $RPM_BUILD_ROOT%sgmlconfdir/xml-docbook-4.1.2.cat
touch $RPM_BUILD_ROOT%sgmlconfdir/sgml-docbook-4.2.cat
touch $RPM_BUILD_ROOT%sgmlconfdir/xml-docbook-4.2.cat
%__ln_s -f sgml-docbook-4.2.cat $RPM_BUILD_ROOT%sgmlconfdir/sgml-docbook.cat
%__ln_s -f xml-docbook-4.2.cat $RPM_BUILD_ROOT%sgmlconfdir/xml-docbook.cat

%files
%doc doc/*
%sgmlbase/docbook/*
%xmlbase/docbook/*
%attr(0644,root,root) %config %sgmlconfdir/sgml-docbook-*.cat
%attr(0644,root,root) %config %sgmlconfdir/xml-docbook-*.cat
%sgmlconfdir/sgml-docbook.cat
%sgmlconfdir/xml-docbook.cat

%post
## NOTE: When editing this section, be sure to replicate changes in the
## triggerpostun sections below.

##
## SGML catalog
##

# Update the centralized catalogs
UpdateCentralized() {
    %_bindir/xmlcatalog --sgml --noout --add \
	%sgmlconfdir/sgml-docbook-$1.cat \
	%sgmlentitiesdir/catalog ||:
    %_bindir/xmlcatalog --sgml --noout --add \
	%sgmlconfdir/sgml-docbook-$1.cat \
	%sgmlbase/docbook/sgml-dtd-$1/catalog ||:
}
UpdateCentralizedXML() {
    %_bindir/xmlcatalog --sgml --noout --add \
	%sgmlconfdir/xml-docbook-$1.cat \
	%sgmlentitiesdir/catalog ||:
    %_bindir/xmlcatalog --sgml --noout --add \
	%sgmlconfdir/xml-docbook-$1.cat \
	%xmlbase/docbook/dtd/$1/catalog ||:
}
UpdateCentralized 3.0
UpdateCentralized 3.1
UpdateCentralized 4.0
UpdateCentralized 4.1
UpdateCentralized 4.2
UpdateCentralizedXML 4.1.2
UpdateCentralizedXML 4.2

# The following lines are for the case in which the style sheets
# were installed after another DTD but before this DTD
AddCatalogFamily() {
    STYLESHEETS=$(echo %sgmlbase/$1-*/catalog)
    [ "$STYLESHEETS" = "%sgmlbase/$1-*/catalog" ] ||
	for s in $STYLESHEETS; do
	    %_bindir/xmlcatalog --sgml --noout --add \
		%sgmlconfdir/sgml-docbook-3.0.cat $s ||:
	    %_bindir/xmlcatalog --sgml --noout --add \
		%sgmlconfdir/sgml-docbook-3.1.cat $s ||:
	    %_bindir/xmlcatalog --sgml --noout --add \
		%sgmlconfdir/sgml-docbook-4.0.cat $s ||:
	    %_bindir/xmlcatalog --sgml --noout --add \
		%sgmlconfdir/sgml-docbook-4.1.cat $s ||:
	    %_bindir/xmlcatalog --sgml --noout --add \
		%sgmlconfdir/xml-docbook-4.1.2.cat $s ||:
	    %_bindir/xmlcatalog --sgml --noout --add \
		%sgmlconfdir/sgml-docbook-4.2.cat $s ||:
	    %_bindir/xmlcatalog --sgml --noout --add \
		%sgmlconfdir/xml-docbook-4.2.cat $s ||:
	done
}
AddCatalogFamily openjade
AddCatalogFamily docbook/dsssl-stylesheets

##
## XML catalog
##

# Clean up the earlier XML DTD 4.1.2 mess
(
    cd %xmlbase/docbook
    for f in dtd/4.1.2/*.{dtd,mod}; do
	%_bindir/xmlcatalog --noout --del "$f" catalog ||:
    done
)

AddXMLCatalog() {
    %_bindir/xmlcatalog --noout --add "delegatePublic" \
	"-//OASIS//DTD DocBook XML V${1}" \
	"file://%xmlbase/dtd/${1}/catalog.xml" %xmlbase/docbook/catalog
}
AddXMLRewrite() {
    %_bindir/xmlcatalog --noout --add "rewriteSystem" \
	"http://www.oasis-open.org/docbook/xml/${1}" \
	"dtd/${2}" %xmlbase/docbook/catalog ||:
    %_bindir/xmlcatalog --noout --add "rewriteURI" \
	"http://www.oasis-open.org/docbook/xml/${1}" \
	"dtd/${2}" %xmlbase/docbook/catalog ||:
}
AddXMLCatalog 4.1.2
AddXMLCatalog 4.2
AddXMLRewrite 4.0 4.1.2
AddXMLRewrite 4.1.2 4.1.2
AddXMLRewrite 4.2 4.2

%preun
if [ $1 = 0 ]; then
    CATALOG=%sgmlconfdir/catalog
    %_bindir/xmlcatalog --sgml --noout --del $CATALOG \
	"%sgmlconfdir/sgml-docbook-3.0.cat" ||:
    %_bindir/xmlcatalog --sgml --noout --del $CATALOG \
	"%sgmlconfdir/sgml-docbook-3.1.cat" ||:
    %_bindir/xmlcatalog --sgml --noout --del $CATALOG \
	"%sgmlconfdir/sgml-docbook-4.0.cat" ||:
    %_bindir/xmlcatalog --sgml --noout --del $CATALOG \
	"%sgmlconfdir/sgml-docbook-4.1.cat" ||:
    %_bindir/xmlcatalog --sgml --noout --del $CATALOG \
	"%sgmlconfdir/sgml-docbook-4.2.cat" ||:
    %_bindir/xmlcatalog --sgml --noout --del $CATALOG \
	"%sgmlconfdir/xml-docbook-4.1.2.cat" ||:
    %_bindir/xmlcatalog --sgml --noout --del $CATALOG \
	"%sgmlconfdir/xml-docbook-4.2.cat" ||:
fi

%postun
RemoveXMLCatalog() {
    if [ ! -d "%xmlbase/docbook/dtd/${1}" ]; then
	%_bindir/xmlcatalog --noout --del \
	    "file://%xmlbase/dtd/${1}/catalog.xml" %xmlbase/docbook/catalog ||:
	%_bindir/xmlcatalog --noout --del \
	    "dtd/${1}" %xmlbase/docbook/catalog ||:
    fi
}
RemoveXMLCatalog 4.1.2
RemoveXMLCatalog 4.2

%triggerpostun -- docbook-dtd30-sgml docbook-dtd31-sgml docbook-dtd40-sgml docbook-dtd41-sgml
# Update the centralized catalogs that might get emptied
UpdateCentralized() {
    %_bindir/xmlcatalog --sgml --noout --add \
	%sgmlconfdir/sgml-docbook-$1.cat \
	%sgmlentitiesdir/catalog ||:
    %_bindir/xmlcatalog --sgml --noout --add \
	%sgmlconfdir/sgml-docbook-$1.cat \
	%sgmlbase/docbook/sgml-dtd-$1/catalog ||:
}
UpdateCentralized 3.0
UpdateCentralized 3.1
UpdateCentralized 4.0
UpdateCentralized 4.1
UpdateCentralized 4.2

AddCatalogFamily() {
    STYLESHEETS=$(echo %sgmlbase/$1-*/catalog)
    [ "$STYLESHEETS" = "%sgmlbase/$1-*/catalog" ] ||
	for s in $STYLESHEETS; do
	    %_bindir/xmlcatalog --sgml --noout --add \
		%sgmlconfdir/sgml-docbook-3.0.cat $s ||:
	    %_bindir/xmlcatalog --sgml --noout --add \
		%sgmlconfdir/sgml-docbook-3.1.cat $s ||:
	    %_bindir/xmlcatalog --sgml --noout --add \
		%sgmlconfdir/sgml-docbook-4.0.cat $s ||:
	    %_bindir/xmlcatalog --sgml --noout --add \
		%sgmlconfdir/sgml-docbook-4.1.cat $s ||:
	done
}
AddCatalogFamily openjade
AddCatalogFamily docbook/dsssl-stylesheets

%__ln_s -f sgml-docbook-4.2.cat %sgmlconfdir/sgml-docbook.cat

%triggerpostun -- docbook-dtd412-xml
##
## SGML catalog
##
UpdateCentralizedXML() {
    %_bindir/xmlcatalog --sgml --noout --add \
	%sgmlconfdir/xml-docbook-$1.cat \
	%sgmlentitiesdir/catalog ||:
    %_bindir/xmlcatalog --sgml --noout --add \
	%sgmlconfdir/xml-docbook-$1.cat \
	%xmlbase/docbook/dtd/$1/catalog ||:
}
UpdateCentralizedXML 4.1.2
UpdateCentralizedXML 4.2

# Special treatment for 4.1.2 that often happens to be referenced as 4.0
# system ID
%_bindir/xmlcatalog --noout --add "rewriteSystem" \
    "http://www.oasis-open.org/docbook/xml/4.0" \
    "dtd/4.1.2" %xmlbase/docbook/catalog ||:
%_bindir/xmlcatalog --noout --add "rewriteURI" \
    "http://www.oasis-open.org/docbook/xml/4.0" \
    "dtd/4.1.2" %xmlbase/docbook/catalog ||:

AddCatalogFamily() {
    STYLESHEETS=$(echo %sgmlbase/$1-*/catalog)
    [ "$STYLESHEETS" = "%sgmlbase/$1-*/catalog" ] ||
	for s in $STYLESHEETS; do
	    %_bindir/xmlcatalog --sgml --noout --add \
		%sgmlconfdir/xml-docbook-4.1.2.cat $s ||:
	    %_bindir/xmlcatalog --sgml --noout --add \
		%sgmlconfdir/xml-docbook-4.2.cat $s ||:
	done
}
AddCatalogFamily openjade
AddCatalogFamily docbook/dsssl-stylesheets

%__ln_s -f xml-docbook-4.2.cat %sgmlconfdir/xml-docbook.cat

##
## XML catalog
##
AddXMLCatalog() {
    %_bindir/xmlcatalog --noout --add "delegatePublic" \
	"-//OASIS//DTD DocBook XML V${1}" \
	"file://%xmlbase/dtd/${1}/catalog.xml" %xmlbase/docbook/catalog
}
AddXMLRewrite() {
    %_bindir/xmlcatalog --noout --add "rewriteSystem" \
	"http://www.oasis-open.org/docbook/xml/${1}" \
	"dtd/${2}" %xmlbase/docbook/catalog ||:
    %_bindir/xmlcatalog --noout --add "rewriteURI" \
	"http://www.oasis-open.org/docbook/xml/${1}" \
	"dtd/${2}" %xmlbase/docbook/catalog ||:
}
AddXMLCatalog 4.1.2
AddXMLCatalog 4.2
AddXMLRewrite 4.0 4.1.2
AddXMLRewrite 4.1.2 4.1.2
AddXMLRewrite 4.2 4.2

%changelog
* Wed Dec 04 2002 Mikhail Zabaluev <mhz@altlinux.ru> 1.0-alt6
- 4.0 system ID rewritten to the 4.1.2 path, as required by
  the DTD documentation.

* Mon Nov 11 2002 Stanislav Ievlev <inger@altlinux.ru> 1.0-alt5
- rebuild

* Wed Jul 31 2002 Mikhail Zabaluev <mhz@altlinux.ru> 1.0-alt4
- Added DTDs for Docbook V4.2 and Docbook XML V4.2
- Create dedicated catalog.xml for 4.1.2 as it's provided in 4.2

* Wed Mar 27 2002 Mikhail Zabaluev <mhz@altlinux.ru> 1.0-alt3
- Use references to system-wide ISO XML character entities
  instead of cool URNs that OpenJade doesn't grok.

* Fri Mar 08 2002 Mikhail Zabaluev <mhz@altlinux.ru> 1.0-alt2
- Made install scripts always happy

* Mon Jan 28 2002 Mikhail Zabaluev <mhz@altlinux.ru> 1.0-alt1
- Adopted to ALT Linux
- Using both /usr/share/sgml and /usr/share/xml
- Listed centralized catalog files as config so they don't just disappear
  and don't require wacky uninstall scripts
- Explicitly remove DTD catalogs from /etc/sgml/catalog on uninstall
- Triggers to fix up after docbook-dtd* uninstallation

* Thu Jan 17 2002 Tim Waugh <twaugh@redhat.com> 1.0-1
- Merged all the DTD packages into one (bug #58448).
- Use /usr/share/sgml exclusively.
- Prevent catalog files from disappearing on upgrade (bug #58463).
